// cellular automatas  redFrik 050612

Pca1 : ListPattern {	//1 dimensional

	var <>rule, <>generation, <>offset, dict;

	*new {|list, rule= 30, generation= 0, repeats= inf, offset= 0|
		^super.new(list, repeats).rule_(rule).generation_(generation).offset_(offset);
	}

	storeArgs {
		^[list, rule, generation, repeats, offset];
	}

	embedInStream {
		var localList;
		dict= ();
		8.do{|i| dict.put(i.asBinaryDigits(3).join.asSymbol, rule.asBinaryDigits[7-i])};
		localList= list.copy.shift(0-offset);
		generation.do{|i| localList= this.prNext(localList)};
		repeats.do{
			localList.do{|cell| cell.yield};
			localList= this.prNext(localList);
		};
	}

	//--private
	prNext {|argList|
		^[0]++argList.slide(3, 1).clump(3).collect{|cell|
			dict[cell.join.asSymbol];
		}++[0];
	}
}
